unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    aPanel : array [0..3] of TPanel;
    count  : integer;
    procedure aPanelMouseEnter(Sender: TObject);
    procedure aPanelMouseLeave(Sender: TObject);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
 if count > 3 then exit;
 aPanel[count]   := TPanel.Create(self);
 aPanel[count].Parent := self;
 aPanel[count].SetBounds(20,50 + (count * 60),100,40);
 aPanel[count].Caption:= aPanel[count].Name;
 aPanel[count].OnMouseEnter:=@aPanelMouseEnter;
 aPanel[count].OnMouseLeave:=@aPanelMouseLeave;
 inc(count);
end;

procedure TForm1.aPanelMouseEnter(Sender: TObject);
var lv: integer;
begin
 for lv := 0 to pred(ComponentCount) do
  if (Components[lv] is TPanel) then
   begin
    TPanel(Components[lv]).Color:= clDefault;
    if TPanel(Components[lv]) = Sender then TPanel(Components[lv]).Color:= clLime;
   end;
end;

procedure TForm1.aPanelMouseLeave(Sender: TObject);
var lv: integer;
begin
 for lv := 0 to pred(ComponentCount) do
  if (Components[lv] is TPanel) then
   TPanel(Components[lv]).Color:= clDefault;

end;

end.

